Index: serefpolicy-contrib-20140730/ppp.te
===================================================================
--- serefpolicy-contrib-20140730.orig/ppp.te
+++ serefpolicy-contrib-20140730/ppp.te
@@ -6,41 +6,47 @@ policy_module(ppp, 1.14.0)
 #
 
 ## <desc>
-##	<p>
-##	Determine whether pppd can
-##	load kernel modules.
-##	</p>
+## <p>
+## Allow pppd to load kernel modules for certain modems
+## </p>
 ## </desc>
 gen_tunable(pppd_can_insmod, false)
 
 ## <desc>
-##	<p>
-##	Determine whether common users can
-##	run pppd with a domain transition.
-##	</p>
+## <p>
+## Allow pppd to be run for a regular user
+## </p>
 ## </desc>
 gen_tunable(pppd_for_user, false)
 
 attribute_role pppd_roles;
-attribute_role pptp_roles;
 
+# pppd_t is the domain for the pppd program.
+# pppd_exec_t is the type of the pppd executable.
 type pppd_t;
 type pppd_exec_t;
 init_daemon_domain(pppd_t, pppd_exec_t)
 role pppd_roles types pppd_t;
+role system_r types pppd_t;
 
 type pppd_devpts_t;
 term_pty(pppd_devpts_t)
 
+# Define a separate type for /etc/ppp
 type pppd_etc_t;
 files_config_file(pppd_etc_t)
 
+# Define a separate type for writable files under /etc/ppp
 type pppd_etc_rw_t;
 files_type(pppd_etc_rw_t)
 
 type pppd_initrc_exec_t alias pppd_script_exec_t;
 init_script_file(pppd_initrc_exec_t)
 
+type pppd_unit_file_t;
+systemd_unit_file(pppd_unit_file_t)
+
+# pppd_secret_t is the type of the pap and chap password files
 type pppd_secret_t;
 files_type(pppd_secret_t)
 
@@ -59,7 +65,8 @@ files_pid_file(pppd_var_run_t)
 type pptp_t;
 type pptp_exec_t;
 init_daemon_domain(pptp_t, pptp_exec_t)
-role pptp_roles types pptp_t;
+#role pppd_roles types pptp_t;
+role system_r types pptp_t;
 
 type pptp_log_t;
 logging_log_file(pptp_log_t)
@@ -67,54 +74,57 @@ logging_log_file(pptp_log_t)
 type pptp_var_run_t;
 files_pid_file(pptp_var_run_t)
 
-type ppp_home_t;
-userdom_user_home_content(ppp_home_t)
-
 ########################################
 #
-# PPPD local policy
+# PPPD Local policy
 #
 
 allow pppd_t self:capability { kill net_admin setuid setgid sys_admin fsetid fowner net_raw dac_override sys_nice };
 dontaudit pppd_t self:capability sys_tty_config;
-allow pppd_t self:process { getsched setsched signal };
+allow pppd_t self:process { getsched setsched signal_perms };
 allow pppd_t self:fifo_file rw_fifo_file_perms;
 allow pppd_t self:socket create_socket_perms;
-allow pppd_t self:netlink_route_socket nlmsg_write;
-allow pppd_t self:tcp_socket { accept listen };
+allow pppd_t self:unix_dgram_socket create_socket_perms;
+allow pppd_t self:unix_stream_socket create_socket_perms;
+allow pppd_t self:netlink_route_socket rw_netlink_socket_perms;
+allow pppd_t self:tcp_socket create_stream_socket_perms;
+allow pppd_t self:udp_socket { connect connected_socket_perms };
 allow pppd_t self:packet_socket create_socket_perms;
 
+domtrans_pattern(pppd_t, pptp_exec_t, pptp_t)
+
 allow pppd_t pppd_devpts_t:chr_file { rw_chr_file_perms setattr_chr_file_perms };
 
 allow pppd_t pppd_etc_t:dir rw_dir_perms;
-allow pppd_t { pppd_etc_t ppp_home_t }:file read_file_perms;
+allow pppd_t pppd_etc_t:file read_file_perms;
 allow pppd_t pppd_etc_t:lnk_file read_lnk_file_perms;
 
 manage_files_pattern(pppd_t, pppd_etc_rw_t, pppd_etc_rw_t)
+# Automatically label newly created files under /etc/ppp with this type
 filetrans_pattern(pppd_t, pppd_etc_t, pppd_etc_rw_t, file)
 
-allow pppd_t pppd_lock_t:file manage_file_perms;
-files_lock_filetrans(pppd_t, pppd_lock_t, file)
+manage_files_pattern(pppd_t, pppd_lock_t, pppd_lock_t)
+files_search_locks(pppd_t)
 
-allow pppd_t pppd_log_t:file { append_file_perms create_file_perms setattr_file_perms };
+manage_files_pattern(pppd_t, pppd_log_t, pppd_log_t)
 logging_log_filetrans(pppd_t, pppd_log_t, file)
 
 manage_dirs_pattern(pppd_t, pppd_tmp_t, pppd_tmp_t)
 manage_files_pattern(pppd_t, pppd_tmp_t, pppd_tmp_t)
-files_tmp_filetrans(pppd_t, pppd_tmp_t, { dir file})
+files_tmp_filetrans(pppd_t, pppd_tmp_t, { file dir })
 
 manage_dirs_pattern(pppd_t, pppd_var_run_t, pppd_var_run_t)
 manage_files_pattern(pppd_t, pppd_var_run_t, pppd_var_run_t)
 files_pid_filetrans(pppd_t, pppd_var_run_t, { dir file })
 
-can_exec(pppd_t, pppd_exec_t)
-
-domtrans_pattern(pppd_t, pptp_exec_t, pptp_t)
-
 allow pppd_t pptp_t:process signal;
 
+# for SSP
+# Access secret files
 allow pppd_t pppd_secret_t:file read_file_perms;
 
+ppp_initrc_domtrans(pppd_t)
+
 kernel_read_kernel_sysctls(pppd_t)
 kernel_read_system_state(pppd_t)
 kernel_rw_net_sysctls(pppd_t)
@@ -122,10 +132,10 @@ kernel_read_network_state(pppd_t)
 kernel_request_load_module(pppd_t)
 
 dev_read_urand(pppd_t)
+dev_search_sysfs(pppd_t)
 dev_read_sysfs(pppd_t)
 dev_rw_modem(pppd_t)
 
-corenet_all_recvfrom_unlabeled(pppd_t)
 corenet_all_recvfrom_netlabel(pppd_t)
 corenet_tcp_sendrecv_generic_if(pppd_t)
 corenet_raw_sendrecv_generic_if(pppd_t)
@@ -135,9 +145,21 @@ corenet_raw_sendrecv_generic_node(pppd_t
 corenet_udp_sendrecv_generic_node(pppd_t)
 corenet_tcp_sendrecv_all_ports(pppd_t)
 corenet_udp_sendrecv_all_ports(pppd_t)
-
+# Access /dev/ppp.
 corenet_rw_ppp_dev(pppd_t)
 
+fs_getattr_all_fs(pppd_t)
+fs_search_auto_mountpoints(pppd_t)
+
+term_use_unallocated_ttys(pppd_t)
+term_use_usb_ttys(pppd_t)
+term_setattr_unallocated_ttys(pppd_t)
+term_ioctl_generic_ptys(pppd_t)
+# for pppoe
+term_create_pty(pppd_t, pppd_devpts_t)
+term_use_generic_ptys(pppd_t)
+
+# allow running ip-up and ip-down scripts and running chat.
 corecmd_exec_bin(pppd_t)
 corecmd_exec_shell(pppd_t)
 
@@ -147,36 +169,31 @@ files_exec_etc_files(pppd_t)
 files_manage_etc_runtime_files(pppd_t)
 files_dontaudit_write_etc_files(pppd_t)
 
-fs_getattr_all_fs(pppd_t)
-fs_search_auto_mountpoints(pppd_t)
+# for scripts
 
-term_use_unallocated_ttys(pppd_t)
-term_setattr_unallocated_ttys(pppd_t)
-term_ioctl_generic_ptys(pppd_t)
-term_create_pty(pppd_t, pppd_devpts_t)
-term_use_generic_ptys(pppd_t)
-
-init_labeled_script_domtrans(pppd_t, pppd_initrc_exec_t)
 init_read_utmp(pppd_t)
-init_signal_script(pppd_t)
 init_dontaudit_write_utmp(pppd_t)
+init_signal_script(pppd_t)
 
-auth_run_chk_passwd(pppd_t, pppd_roles)
 auth_use_nsswitch(pppd_t)
+auth_domtrans_chk_passwd(pppd_t)
+#auth_run_chk_passwd(pppd_t,pppd_roles)
 auth_write_login_records(pppd_t)
 
 logging_send_syslog_msg(pppd_t)
 logging_send_audit_msgs(pppd_t)
 
-miscfiles_read_localization(pppd_t)
-
 sysnet_exec_ifconfig(pppd_t)
 sysnet_manage_config(pppd_t)
 sysnet_etc_filetrans_config(pppd_t)
+sysnet_filetrans_config_fromdir(pppd_t, pppd_var_run_t, file, "resolv.conf")
 
-userdom_use_user_terminals(pppd_t)
+userdom_use_inherited_user_terminals(pppd_t)
 userdom_dontaudit_use_unpriv_user_fds(pppd_t)
 userdom_search_user_home_dirs(pppd_t)
+userdom_search_admin_dir(pppd_t)
+
+ppp_exec(pppd_t)
 
 optional_policy(`
 	ddclient_run(pppd_t, pppd_roles)
@@ -186,11 +203,13 @@ optional_policy(`
 	l2tpd_dgram_send(pppd_t)
 	l2tpd_rw_socket(pppd_t)
 	l2tpd_stream_connect(pppd_t)
+    l2tpd_read_pid_files(pppd_t)
+    l2tpd_dbus_chat(pppd_t)
 ')
 
 optional_policy(`
 	tunable_policy(`pppd_can_insmod',`
-		modutils_domtrans_insmod(pppd_t)
+		modutils_domtrans_insmod_uncond(pppd_t)
 	')
 ')
 
@@ -218,16 +237,19 @@ optional_policy(`
 
 ########################################
 #
-# PPTP local policy
+# PPTP Local policy
 #
 
 allow pptp_t self:capability { dac_override dac_read_search net_raw net_admin };
 dontaudit pptp_t self:capability sys_tty_config;
 allow pptp_t self:process signal;
 allow pptp_t self:fifo_file rw_fifo_file_perms;
-allow pptp_t self:unix_stream_socket { accept connectto listen };
+allow pptp_t self:unix_dgram_socket create_socket_perms;
+allow pptp_t self:unix_stream_socket { connectto create_stream_socket_perms };
 allow pptp_t self:rawip_socket create_socket_perms;
-allow pptp_t self:netlink_route_socket nlmsg_write;
+allow pptp_t self:tcp_socket create_socket_perms;
+allow pptp_t self:udp_socket create_socket_perms;
+allow pptp_t self:netlink_route_socket rw_netlink_socket_perms;
 
 allow pptp_t pppd_etc_t:dir list_dir_perms;
 allow pptp_t pppd_etc_t:file read_file_perms;
@@ -236,45 +258,43 @@ allow pptp_t pppd_etc_t:lnk_file read_ln
 allow pptp_t pppd_etc_rw_t:dir list_dir_perms;
 allow pptp_t pppd_etc_rw_t:file read_file_perms;
 allow pptp_t pppd_etc_rw_t:lnk_file read_lnk_file_perms;
+can_exec(pptp_t, pppd_etc_rw_t)
 
+# Allow pptp to append to pppd log files
 allow pptp_t pppd_log_t:file append_file_perms;
 
-allow pptp_t pptp_log_t:file { append_file_perms create_file_perms setattr_file_perms };
+allow pptp_t pptp_log_t:file manage_file_perms;
 logging_log_filetrans(pptp_t, pptp_log_t, file)
 
+manage_dirs_pattern(pptp_t, pptp_var_run_t, pptp_var_run_t)
 manage_files_pattern(pptp_t, pptp_var_run_t, pptp_var_run_t)
 manage_sock_files_pattern(pptp_t, pptp_var_run_t, pptp_var_run_t)
-files_pid_filetrans(pptp_t, pptp_var_run_t, file)
-
-can_exec(pptp_t, pppd_etc_rw_t)
+files_pid_filetrans(pptp_t, pptp_var_run_t, { file dir })
 
+kernel_list_proc(pptp_t)
 kernel_read_kernel_sysctls(pptp_t)
 kernel_read_network_state(pptp_t)
+kernel_read_proc_symlinks(pptp_t)
 kernel_read_system_state(pptp_t)
 kernel_signal(pptp_t)
 
+dev_read_sysfs(pptp_t)
+
 corecmd_exec_shell(pptp_t)
 corecmd_read_bin_symlinks(pptp_t)
 
-corenet_all_recvfrom_unlabeled(pptp_t)
 corenet_all_recvfrom_netlabel(pptp_t)
 corenet_tcp_sendrecv_generic_if(pptp_t)
 corenet_raw_sendrecv_generic_if(pptp_t)
 corenet_tcp_sendrecv_generic_node(pptp_t)
 corenet_raw_sendrecv_generic_node(pptp_t)
 corenet_tcp_sendrecv_all_ports(pptp_t)
-
-corenet_tcp_connect_all_reserved_ports(pptp_t)
+corenet_tcp_bind_generic_node(pptp_t)
 corenet_tcp_connect_generic_port(pptp_t)
+corenet_tcp_connect_all_reserved_ports(pptp_t)
 corenet_sendrecv_generic_client_packets(pptp_t)
-
-corenet_sendrecv_pptp_client_packets(pptp_t)
 corenet_tcp_connect_pptp_port(pptp_t)
 
-dev_read_sysfs(pptp_t)
-
-domain_use_interactive_fds(pptp_t)
-
 fs_getattr_all_fs(pptp_t)
 fs_search_auto_mountpoints(pptp_t)
 
@@ -282,12 +302,12 @@ term_ioctl_generic_ptys(pptp_t)
 term_search_ptys(pptp_t)
 term_use_ptmx(pptp_t)
 
+domain_use_interactive_fds(pptp_t)
+
 auth_use_nsswitch(pptp_t)
 
 logging_send_syslog_msg(pptp_t)
 
-miscfiles_read_localization(pptp_t)
-
 sysnet_exec_ifconfig(pptp_t)
 
 userdom_dontaudit_use_unpriv_user_fds(pptp_t)
@@ -299,6 +319,10 @@ optional_policy(`
 ')
 
 optional_policy(`
+    gnome_dontaudit_search_config(pppd_t)
+')
+
+optional_policy(`
 	dbus_system_domain(pppd_t, pppd_exec_t)
 
 	optional_policy(`
Index: serefpolicy-contrib-20140730/prelink.if
===================================================================
--- serefpolicy-contrib-20140730.orig/prelink.if
+++ serefpolicy-contrib-20140730/prelink.if
@@ -2,7 +2,7 @@
 
 ########################################
 ## <summary>
-##	Execute prelink in the prelink domain.
+##	Execute the prelink program in the prelink domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -18,15 +18,15 @@ interface(`prelink_domtrans',`
 	corecmd_search_bin($1)
 	domtrans_pattern($1, prelink_exec_t, prelink_t)
 
-	ifdef(`hide_broken_symptoms',`
+	ifdef(`hide_broken_symptoms', `
 		dontaudit prelink_t $1:socket_class_set { read write };
-		dontaudit prelink_t $1:fifo_file setattr_fifo_file_perms;
+		dontaudit prelink_t $1:fifo_file setattr;
 	')
 ')
 
 ########################################
 ## <summary>
-##	Execute prelink in the caller domain.
+##	Execute the prelink program in the current domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -45,9 +45,7 @@ interface(`prelink_exec',`
 
 ########################################
 ## <summary>
-##	Execute prelink in the prelink
-##	domain, and allow the specified role
-##	the prelink domain.
+##	Execute the prelink program in the prelink domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -56,18 +54,18 @@ interface(`prelink_exec',`
 ## </param>
 ## <param name="role">
 ##	<summary>
-##	Role allowed access.
+##	The role to allow the prelink domain.
 ##	</summary>
 ## </param>
 ## <rolecap/>
 #
 interface(`prelink_run',`
 	gen_require(`
-		attribute_role prelink_roles;
+		type prelink_t;
 	')
 
 	prelink_domtrans($1)
-	roleattribute $2 prelink_roles;
+	role $2 types prelink_t;
 ')
 
 ########################################
@@ -80,6 +78,7 @@ interface(`prelink_run',`
 ##	</summary>
 ## </param>
 #
+# cjp: added for misc non-entrypoint objects
 interface(`prelink_object_file',`
 	gen_require(`
 		attribute prelink_object;
@@ -90,7 +89,7 @@ interface(`prelink_object_file',`
 
 ########################################
 ## <summary>
-##	Read prelink cache files.
+##	Read the prelink cache.
 ## </summary>
 ## <param name="file_type">
 ##	<summary>
@@ -109,7 +108,7 @@ interface(`prelink_read_cache',`
 
 ########################################
 ## <summary>
-##	Delete prelink cache files.
+##	Delete the prelink cache.
 ## </summary>
 ## <param name="file_type">
 ##	<summary>
@@ -122,8 +121,8 @@ interface(`prelink_delete_cache',`
 		type prelink_cache_t;
 	')
 
+	allow $1 prelink_cache_t:file unlink;
 	files_rw_etc_dirs($1)
-	allow $1 prelink_cache_t:file delete_file_perms;
 ')
 
 ########################################
@@ -168,7 +167,7 @@ interface(`prelink_manage_lib',`
 
 ########################################
 ## <summary>
-##	Relabel from prelink lib files.
+##	Relabel from files in the /boot directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -187,7 +186,7 @@ interface(`prelink_relabelfrom_lib',`
 
 ########################################
 ## <summary>
-##	Relabel prelink lib files.
+##	Relabel from files in the /boot directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -203,3 +202,21 @@ interface(`prelink_relabel_lib',`
 	files_search_var_lib($1)
 	relabel_files_pattern($1, prelink_var_lib_t, prelink_var_lib_t)
 ')
+
+########################################
+## <summary>
+##	Transition to prelink named content
+## </summary>
+## <param name="domain">
+##	<summary>
+##      Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`prelink_filetrans_named_content',`
+	gen_require(`
+		type prelink_cache_t;
+	')
+
+	files_etc_filetrans($1, prelink_cache_t, file, "prelink.cache")
+')
Index: serefpolicy-contrib-20140730/prelink.te
===================================================================
--- serefpolicy-contrib-20140730.orig/prelink.te
+++ serefpolicy-contrib-20140730/prelink.te
@@ -6,13 +6,10 @@ policy_module(prelink, 1.11.0)
 
 attribute prelink_object;
 
-attribute_role prelink_roles;
-
 type prelink_t;
 type prelink_exec_t;
 init_system_domain(prelink_t, prelink_exec_t)
 domain_obj_id_change_exemption(prelink_t)
-role prelink_roles types prelink_t;
 
 type prelink_cache_t;
 files_type(prelink_cache_t)
@@ -47,24 +44,27 @@ allow prelink_t self:fifo_file rw_fifo_f
 allow prelink_t prelink_cache_t:file manage_file_perms;
 files_etc_filetrans(prelink_t, prelink_cache_t, file)
 
-allow prelink_t prelink_log_t:dir setattr_dir_perms;
+allow prelink_t prelink_log_t:dir setattr;
 create_files_pattern(prelink_t, prelink_log_t, prelink_log_t)
 append_files_pattern(prelink_t, prelink_log_t, prelink_log_t)
 read_lnk_files_pattern(prelink_t, prelink_log_t, prelink_log_t)
 logging_log_filetrans(prelink_t, prelink_log_t, file)
 
-allow prelink_t prelink_tmp_t:file { manage_file_perms mmap_file_perms relabel_file_perms execmod };
+allow prelink_t prelink_tmp_t:file { manage_file_perms execute relabelfrom execmod };
 files_tmp_filetrans(prelink_t, prelink_tmp_t, file)
 
-allow prelink_t prelink_tmpfs_t:file { manage_file_perms mmap_file_perms relabel_file_perms execmod };
+allow prelink_t prelink_tmpfs_t:file { manage_file_perms execute relabelfrom execmod };
 fs_tmpfs_filetrans(prelink_t, prelink_tmpfs_t, file)
 
 manage_dirs_pattern(prelink_t, prelink_var_lib_t, prelink_var_lib_t)
 manage_files_pattern(prelink_t, prelink_var_lib_t, prelink_var_lib_t)
 relabel_files_pattern(prelink_t, prelink_var_lib_t, prelink_var_lib_t)
 files_var_lib_filetrans(prelink_t, prelink_var_lib_t, { dir file })
+files_search_var_lib(prelink_t)
 
-allow prelink_t prelink_object:file { manage_file_perms mmap_file_perms relabel_file_perms };
+# prelink misc objects that are not system
+# libraries or entrypoints
+allow prelink_t prelink_object:file { manage_file_perms execute relabel_file_perms };
 
 kernel_read_system_state(prelink_t)
 kernel_read_kernel_sysctls(prelink_t)
@@ -75,25 +75,23 @@ corecmd_mmap_all_executables(prelink_t)
 corecmd_read_bin_symlinks(prelink_t)
 
 dev_read_urand(prelink_t)
+dev_getattr_all_chr_files(prelink_t)
 
-files_getattr_all_files(prelink_t)
 files_list_all(prelink_t)
+files_getattr_all_files(prelink_t)
+files_write_non_security_dirs(prelink_t)
+files_read_etc_runtime_files(prelink_t)
+files_dontaudit_read_all_symlinks(prelink_t)
 files_manage_usr_files(prelink_t)
 files_manage_var_files(prelink_t)
-files_read_etc_files(prelink_t)
-files_read_etc_runtime_files(prelink_t)
 files_relabelfrom_usr_files(prelink_t)
-files_search_var_lib(prelink_t)
-files_write_non_security_dirs(prelink_t)
-files_dontaudit_read_all_symlinks(prelink_t)
 
-fs_getattr_all_fs(prelink_t)
-fs_search_auto_mountpoints(prelink_t)
-
-selinux_get_enforce_mode(prelink_t)
+fs_getattr_xattr_fs(prelink_t)
 
 storage_getattr_fixed_disk_dev(prelink_t)
 
+selinux_get_enforce_mode(prelink_t)
+
 libs_exec_ld_so(prelink_t)
 libs_legacy_use_shared_libs(prelink_t)
 libs_manage_ld_so(prelink_t)
@@ -102,32 +100,16 @@ libs_manage_shared_libs(prelink_t)
 libs_relabel_shared_libs(prelink_t)
 libs_delete_lib_symlinks(prelink_t)
 
-miscfiles_read_localization(prelink_t)
 
-userdom_use_user_terminals(prelink_t)
-userdom_manage_user_home_content_files(prelink_t)
-# pending
-# userdom_relabel_user_home_content_files(prelink_t)
-# userdom_execmod_user_home_content_files(prelink_t)
+userdom_use_inherited_user_terminals(prelink_t)
+userdom_manage_user_home_content(prelink_t)
+userdom_relabel_user_home_files(prelink_t)
+userdom_execmod_user_home_files(prelink_t)
 userdom_exec_user_home_content_files(prelink_t)
 
-ifdef(`hide_broken_symptoms',`
-	miscfiles_read_man_pages(prelink_t)
+systemd_read_unit_files(prelink_t)
 
-	optional_policy(`
-		dbus_read_config(prelink_t)
-	')
-')
-
-tunable_policy(`use_nfs_home_dirs',`
-	fs_exec_nfs_files(prelink_t)
-	fs_manage_nfs_files(prelink_t)
-')
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_exec_cifs_files(prelink_t)
-	fs_manage_cifs_files(prelink_t)
-')
+term_use_all_inherited_terms(prelink_t)
 
 optional_policy(`
 	amanda_manage_lib(prelink_t)
@@ -138,11 +120,12 @@ optional_policy(`
 ')
 
 optional_policy(`
+	gnome_dontaudit_read_config(prelink_t)
 	gnome_dontaudit_read_inherited_gconf_config_files(prelink_t)
 ')
 
 optional_policy(`
-	mozilla_manage_plugin_rw_files(prelink_t)
+	mozilla_plugin_manage_rw_files(prelink_t)
 ')
 
 optional_policy(`
@@ -155,17 +138,18 @@ optional_policy(`
 
 ########################################
 #
-# Cron system local policy
+# Prelink Cron system Policy
 #
 
 optional_policy(`
 	allow prelink_cron_system_t self:capability setuid;
 	allow prelink_cron_system_t self:process { setsched setfscreate signal };
 	allow prelink_cron_system_t self:fifo_file rw_fifo_file_perms;
-	allow prelink_cron_system_t self:unix_dgram_socket create_socket_perms;
+	allow prelink_cron_system_t self:unix_dgram_socket { write bind create setopt };
 
 	read_files_pattern(prelink_cron_system_t, prelink_cache_t, prelink_cache_t)
-	allow prelink_cron_system_t prelink_cache_t:file delete_file_perms;
+	allow prelink_cron_system_t prelink_cache_t:file unlink;
+	files_delete_etc_dir_entry(prelink_cron_system_t)
 
 	domtrans_pattern(prelink_cron_system_t, prelink_exec_t, prelink_t)
 	allow prelink_cron_system_t prelink_t:process noatsecure;
@@ -174,7 +158,7 @@ optional_policy(`
 
 	manage_files_pattern(prelink_cron_system_t, prelink_var_lib_t, prelink_var_lib_t)
 	files_var_lib_filetrans(prelink_cron_system_t, prelink_var_lib_t, file)
-	allow prelink_cron_system_t prelink_var_lib_t:file relabel_file_perms;
+	allow prelink_cron_system_t prelink_var_lib_t:file { relabelfrom relabelto };
 
 	kernel_read_system_state(prelink_cron_system_t)
 
@@ -184,23 +168,36 @@ optional_policy(`
 	dev_list_sysfs(prelink_cron_system_t)
 	dev_read_sysfs(prelink_cron_system_t)
 
-	files_rw_etc_dirs(prelink_cron_system_t)
 	files_dontaudit_search_all_mountpoints(prelink_cron_system_t)
+	files_search_var_lib(prelink_cron_system_t)
+	files_dontaudit_list_non_security(prelink_cron_system_t)
+
+	fs_search_cgroup_dirs(prelink_cron_system_t)
 
 	auth_use_nsswitch(prelink_cron_system_t)
 
 	init_telinit(prelink_cron_system_t)
 	init_exec(prelink_cron_system_t)
+	init_reload_services(prelink_cron_system_t)
 
 	libs_exec_ld_so(prelink_cron_system_t)
 
 	logging_search_logs(prelink_cron_system_t)
 
-	miscfiles_read_localization(prelink_cron_system_t)
+	init_stream_connect(prelink_cron_system_t)
+
 
 	cron_system_entry(prelink_cron_system_t, prelink_cron_system_exec_t)
 
+	userdom_dontaudit_list_admin_dir(prelink_cron_system_t)
+
 	optional_policy(`
 		rpm_read_db(prelink_cron_system_t)
 	')
 ')
+
+ifdef(`hide_broken_symptoms', `
+	optional_policy(`
+	      dbus_read_config(prelink_t)
+	')
+')
Index: serefpolicy-contrib-20140730/prelude.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/prelude.fc
+++ serefpolicy-contrib-20140730/prelude.fc
@@ -12,7 +12,7 @@
 
 /usr/sbin/audisp-prelude	--	gen_context(system_u:object_r:prelude_audisp_exec_t,s0)
 
-/usr/share/prewikka/cgi-bin(/.*)?	gen_context(system_u:object_r:httpd_prewikka_script_exec_t,s0)
+/usr/share/prewikka/cgi-bin(/.*)?	gen_context(system_u:object_r:prewikka_script_exec_t,s0)
 
 /var/lib/prelude-lml(/.*)?	gen_context(system_u:object_r:prelude_var_lib_t,s0)
 
Index: serefpolicy-contrib-20140730/prelude.if
===================================================================
--- serefpolicy-contrib-20140730.orig/prelude.if
+++ serefpolicy-contrib-20140730/prelude.if
@@ -1,13 +1,13 @@
-## <summary>Prelude hybrid intrusion detection system.</summary>
+## <summary>Prelude hybrid intrusion detection system</summary>
 
 ########################################
 ## <summary>
 ##	Execute a domain transition to run prelude.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## <summary>
 ##	Domain allowed to transition.
-##	</summary>
+## </summary>
 ## </param>
 #
 interface(`prelude_domtrans',`
@@ -15,19 +15,17 @@ interface(`prelude_domtrans',`
 		type prelude_t, prelude_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, prelude_exec_t, prelude_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute a domain transition to
-##	run prelude audisp.
+##	Execute a domain transition to run prelude_audisp.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## <summary>
 ##	Domain allowed to transition.
-##	</summary>
+## </summary>
 ## </param>
 #
 interface(`prelude_domtrans_audisp',`
@@ -35,18 +33,17 @@ interface(`prelude_domtrans_audisp',`
 		type prelude_audisp_t, prelude_audisp_exec_t;
 	')
 
-	corecmd_search_bin($1)
 	domtrans_pattern($1, prelude_audisp_exec_t, prelude_audisp_t)
 ')
 
 ########################################
 ## <summary>
-##	Send generic signals to prelude audisp.
+##	Signal the prelude_audisp domain.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+## <summary>
+##	Domain allowed acccess.
+## </summary>
 ## </param>
 #
 interface(`prelude_signal_audisp',`
@@ -59,7 +56,7 @@ interface(`prelude_signal_audisp',`
 
 ########################################
 ## <summary>
-##	Read prelude spool files.
+##	Read the prelude spool files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -78,13 +75,12 @@ interface(`prelude_read_spool',`
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	prelude manager spool files.
+##	Manage to prelude-manager spool files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
+## <summary>
 ##	Domain allowed access.
-##	</summary>
+## </summary>
 ## </param>
 #
 interface(`prelude_manage_spool',`
@@ -99,8 +95,8 @@ interface(`prelude_manage_spool',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an prelude environment.
+##	All of the rules required to administrate 
+##	an prelude environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -116,32 +112,42 @@ interface(`prelude_manage_spool',`
 #
 interface(`prelude_admin',`
 	gen_require(`
-		type prelude_t, prelude_spool_t, prelude_lml_var_run_t;
-		type prelude_var_run_t, prelude_var_lib_t, prelude_log_t;
-		type prelude_audisp_t, prelude_audisp_var_run_t;
-		type prelude_initrc_exec_t, prelude_lml_t, prelude_lml_tmp_t;
+		type prelude_t, prelude_spool_t, prelude_initrc_exec_t;
+		type prelude_var_run_t, prelude_var_lib_t, prelude_lml_var_run_t;
+		type prelude_audisp_t, prelude_audisp_var_run_t, prelude_lml_tmp_t;
+		type prelude_lml_t;
 	')
 
-	allow $1 { prelude_t prelude_audisp_t prelude_lml_t prelude_correlator_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { prelude_t prelude_audisp_t prelude_lml_t prelude_correlator_t })
+	allow $1 prelude_t:process signal_perms;
+	ps_process_pattern($1, prelude_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 prelude_t:process ptrace;
+		allow $1 prelude_audisp_t:process ptrace;
+		allow $1 prelude_lml_t:process ptrace;
+	')
+
+	allow $1 prelude_audisp_t:process signal_perms;
+	ps_process_pattern($1, prelude_audisp_t)
+
+	allow $1 prelude_lml_t:process signal_perms;
+	ps_process_pattern($1, prelude_lml_t)
 
 	init_labeled_script_domtrans($1, prelude_initrc_exec_t)
 	domain_system_change_exemption($1)
 	role_transition $2 prelude_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_search_spool($1)
+	files_list_spool($1)
 	admin_pattern($1, prelude_spool_t)
 
-	logging_search_logs($1)
-	admin_pattern($1, prelude_log_t)
-
-	files_search_var_lib($1)
+	files_list_var_lib($1)
 	admin_pattern($1, prelude_var_lib_t)
 
-	files_search_pids($1)
-	admin_pattern($1, { prelude_audisp_var_run_t prelude_var_run_t prelude_lml_var_run_t })
+	files_list_pids($1)
+	admin_pattern($1, prelude_var_run_t)
+	admin_pattern($1, prelude_audisp_var_run_t)
+	admin_pattern($1, prelude_lml_var_run_t)
 
-	files_search_tmp($1)
+	files_list_tmp($1)
 	admin_pattern($1, prelude_lml_tmp_t)
 ')
Index: serefpolicy-contrib-20140730/prelude.te
===================================================================
--- serefpolicy-contrib-20140730.orig/prelude.te
+++ serefpolicy-contrib-20140730/prelude.te
@@ -13,7 +13,7 @@ type prelude_initrc_exec_t;
 init_script_file(prelude_initrc_exec_t)
 
 type prelude_spool_t;
-files_type(prelude_spool_t)
+files_spool_file(prelude_spool_t)
 
 type prelude_log_t;
 logging_log_file(prelude_log_t)
@@ -81,7 +81,6 @@ kernel_read_sysctl(prelude_t)
 
 corecmd_search_bin(prelude_t)
 
-corenet_all_recvfrom_unlabeled(prelude_t)
 corenet_all_recvfrom_netlabel(prelude_t)
 corenet_tcp_sendrecv_generic_if(prelude_t)
 corenet_tcp_sendrecv_generic_node(prelude_t)
@@ -97,7 +96,6 @@ dev_read_rand(prelude_t)
 dev_read_urand(prelude_t)
 
 files_read_etc_runtime_files(prelude_t)
-files_read_usr_files(prelude_t)
 files_search_spool(prelude_t)
 files_search_tmp(prelude_t)
 
@@ -108,8 +106,6 @@ auth_use_nsswitch(prelude_t)
 logging_send_audit_msgs(prelude_t)
 logging_send_syslog_msg(prelude_t)
 
-miscfiles_read_localization(prelude_t)
-
 optional_policy(`
 	mysql_stream_connect(prelude_t)
 	mysql_tcp_connect(prelude_t)
@@ -141,7 +137,6 @@ kernel_read_system_state(prelude_audisp_
 
 corecmd_search_bin(prelude_audisp_t)
 
-corenet_all_recvfrom_unlabeled(prelude_audisp_t)
 corenet_all_recvfrom_netlabel(prelude_audisp_t)
 corenet_tcp_sendrecv_generic_if(prelude_audisp_t)
 corenet_tcp_sendrecv_generic_node(prelude_audisp_t)
@@ -155,15 +150,12 @@ dev_read_urand(prelude_audisp_t)
 
 domain_use_interactive_fds(prelude_audisp_t)
 
-files_read_etc_files(prelude_audisp_t)
 files_read_etc_runtime_files(prelude_audisp_t)
 files_search_spool(prelude_audisp_t)
 files_search_tmp(prelude_audisp_t)
 
 logging_send_syslog_msg(prelude_audisp_t)
 
-miscfiles_read_localization(prelude_audisp_t)
-
 sysnet_dns_name_resolve(prelude_audisp_t)
 
 ########################################
@@ -184,7 +176,6 @@ kernel_read_sysctl(prelude_correlator_t)
 
 corecmd_search_bin(prelude_correlator_t)
 
-corenet_all_recvfrom_unlabeled(prelude_correlator_t)
 corenet_all_recvfrom_netlabel(prelude_correlator_t)
 corenet_tcp_sendrecv_generic_if(prelude_correlator_t)
 corenet_tcp_sendrecv_generic_node(prelude_correlator_t)
@@ -196,14 +187,10 @@ corenet_tcp_sendrecv_prelude_port(prelud
 dev_read_rand(prelude_correlator_t)
 dev_read_urand(prelude_correlator_t)
 
-files_read_etc_files(prelude_correlator_t)
-files_read_usr_files(prelude_correlator_t)
 files_search_spool(prelude_correlator_t)
 
 logging_send_syslog_msg(prelude_correlator_t)
 
-miscfiles_read_localization(prelude_correlator_t)
-
 sysnet_dns_name_resolve(prelude_correlator_t)
 
 ########################################
@@ -212,6 +199,8 @@ sysnet_dns_name_resolve(prelude_correlat
 #
 
 allow prelude_lml_t self:capability dac_override;
+allow prelude_lml_t self:tcp_socket { setopt create_socket_perms };
+allow prelude_lml_t self:unix_dgram_socket create_socket_perms;
 allow prelude_lml_t self:fifo_file rw_fifo_file_perms;
 allow prelude_lml_t self:unix_stream_socket connectto;
 
@@ -262,8 +251,6 @@ libs_read_lib_files(prelude_lml_t)
 logging_send_syslog_msg(prelude_lml_t)
 logging_read_generic_logs(prelude_lml_t)
 
-miscfiles_read_localization(prelude_lml_t)
-
 userdom_read_all_users_state(prelude_lml_t)
 
 optional_policy(`
@@ -278,27 +265,28 @@ optional_policy(`
 
 optional_policy(`
 	apache_content_template(prewikka)
+	apache_content_alias_template(prewikka, prewikka)
 
-	can_exec(httpd_prewikka_script_t, httpd_prewikka_script_exec_t)
+	can_exec(prewikka_script_t, prewikka_script_exec_t)
 
-	files_search_tmp(httpd_prewikka_script_t)
+	files_search_tmp(prewikka_script_t)
 
-	kernel_read_sysctl(httpd_prewikka_script_t)
-	kernel_search_network_sysctl(httpd_prewikka_script_t)
+	kernel_read_sysctl(prewikka_script_t)
+	kernel_search_network_sysctl(prewikka_script_t)
 
-	auth_use_nsswitch(httpd_prewikka_script_t)
+	auth_use_nsswitch(prewikka_script_t)
 
-	logging_send_syslog_msg(httpd_prewikka_script_t)
+	logging_send_syslog_msg(prewikka_script_t)
 
-	apache_search_sys_content(httpd_prewikka_script_t)
+	apache_search_sys_content(prewikka_script_t)
 
 	optional_policy(`
-		mysql_stream_connect(httpd_prewikka_script_t)
-		mysql_tcp_connect(httpd_prewikka_script_t)
+		mysql_stream_connect(prewikka_script_t)
+		mysql_tcp_connect(prewikka_script_t)
 	')
 
 	optional_policy(`
-		postgresql_stream_connect(httpd_prewikka_script_t)
-		postgresql_tcp_connect(httpd_prewikka_script_t)
+		postgresql_stream_connect(prewikka_script_t)
+		postgresql_tcp_connect(prewikka_script_t)
 	')
 ')
Index: serefpolicy-contrib-20140730/privoxy.if
===================================================================
--- serefpolicy-contrib-20140730.orig/privoxy.if
+++ serefpolicy-contrib-20140730/privoxy.if
@@ -23,8 +23,11 @@ interface(`privoxy_admin',`
 		type privoxy_etc_rw_t, privoxy_var_run_t;
 	')
 
-	allow $1 privoxy_t:process { ptrace signal_perms };
+	allow $1 privoxy_t:process signal_perms;
 	ps_process_pattern($1, privoxy_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 privoxy_t:process ptrace;
+	')
 
 	init_labeled_script_domtrans($1, privoxy_initrc_exec_t)
 	domain_system_change_exemption($1)
